;==============================================================================
    include \masm32\include\masm32rt.inc
;==============================================================================

printf MACRO format:REQ, args:VARARG
    IFNB <args>
        invoke crt_printf, cfm$(format), args
    ELSE
        invoke crt_printf, cfm$(format)
    ENDIF
    EXITM <>
ENDM

;==============================================================================

;---------------------------------------
; Returns the maximum alignment of ptr.
;---------------------------------------

alignment MACRO ptr
    push ecx
    xor eax, eax
    mov ecx, ptr
    bsf ecx, ecx
    jz @F
    mov eax, 1
    shl eax, cl
  @@:
    pop ecx
    EXITM <eax>
ENDM

;==============================================================================
    .data
    .code
;==============================================================================
start:
;==============================================================================

    ;--------------------------------------------------------------
    ; This code does not free the allocated memory to avoid having
    ; the functions allocate the same block repeatedly.
    ;--------------------------------------------------------------

    printf("alloc$ macro [SysAllocStringByteLen] :\n\n")
    REPEAT 10
        mov ebx, alloc$(16384)
        printf("%d\t", alignment(ebx))
    ENDM

    printf("\nalloc macro [GlobalAlloc] :\n\n")
    REPEAT 10
      mov ebx, alloc(16384)
      printf("%d\t", alignment(ebx))
    ENDM

    printf("\nLocalAlloc :\n\n")
    REPEAT 10
      invoke LocalAlloc, LMEM_FIXED, 16384
      mov ebx, eax
      printf("%d\t", alignment(ebx))
    ENDM

    printf("\nhalloc macro [HeapAlloc] :\n\n")
    REPEAT 10
      mov ebx, halloc(16384)
      printf("%d\t", alignment(ebx))
    ENDM

    printf("\nAlloc :\n\n")
    REPEAT 10
      invoke Alloc, 16384
      mov ebx, eax
      printf("%d\t", alignment(ebx))
    ENDM

    printf("\nCoTaskMemAlloc :\n\n")
    REPEAT 10
      invoke CoTaskMemAlloc, 16384
      mov ebx, eax
      printf("%d\t", alignment(ebx))
    ENDM

    printf("\ncrt_malloc :\n\n")
    REPEAT 10
      invoke crt_malloc, 16384
      mov ebx, eax
      printf("%d\t", alignment(ebx))
    ENDM

    printf("\nVirtualAlloc :\n\n")
    REPEAT 10
      invoke VirtualAlloc, NULL, 16384, MEM_COMMIT, PAGE_READWRITE
      mov ebx, eax
      printf("%d\t", alignment(ebx))
    ENDM

    printf("\n\n")

    inkey "Press any key to exit..."
    exit
;==============================================================================
end start
